% Feb 20th 2020.
%Authors:  Eric J. Goldfarb, Ken Ikeda, Richard A. Ketcham, Maa Prodanovi? and Nicola Tisato



function [porosity_matrix,rock_porosity ] = Density2Porosity(data,upper_limit)
%inputs are 3D data in units of density, and the max phase density. scale
%between 1 (density of air) and the max phase value
density=[1 upper_limit];
porosity=[1 0]; %porosity is scaled between 0 and 1



ft = fittype( 'poly1' );

%two equations are made: one to be used for values less than quartz's density,
%and one for values greater than quartz. This is "porosity max"

[porosity_equation] = fit( density',porosity', ft );



%set values <0 to 0 and > upper limit to the upper limit.
porosity_matrix=porosity_equation(data);
porosity_matrix(porosity_matrix<0)=0;
porosity_matrix(porosity_matrix>upper_limit)=upper_limit;

porosity_matrix=reshape(porosity_matrix,size(data,1),size(data,2),size(data,3));


rock_porosity=nanmean(porosity_matrix(:)).*100

end

